{-# LANGUAGE RankNTypes #-}
module Benchmark where

import Control.Monad
import Control.Monad.ST
import Data.STRef
import Data.IORef

import GHC.Prim
import Criterion.Measurement

import Control.DeepSeq

benchmarkST :: forall a. (forall s. ST s a) -> IO Double
benchmarkST expr = do
    t1 <- getTime
    let result = runST expr
    t2 <- result `seq` getTime
    return (t2-t1)

benchmarkIO expr = do
    t1 <- getTime
    result <- expr
    t2 <- result `seq` getTime
    return (t2-t1)

benchmarkPure expr = do
    t1 <- getTime
    t2 <- expr `deepseq` getTime
    return (expr,(t2-t1))