{-#LANGUAGE OverloadedStrings #-}
{-#LANGUAGE MagicHash         #-}
{-#LANGUAGE BangPatterns      #-}
module Main (main) where

import Control.Monad
import Control.Monad.ST
import Data.STRef
import Data.IORef

import GHC.Prim
import GHC.Types
import Criterion.Measurement

import System.Environment

import Benchmark

help = "The problem: \nBenchmark of a problem: updating a variable n times\n"

ioProblem n = do
    v <- newIORef 0
    forM_ [0..n-1] $ \_ ->
        modifyIORef' v (+1)
    readIORef v

ioProblem2 n = ioProblem2' n =<< newIORef 0 

ioProblem2' !0 ref = readIORef ref
ioProblem2' !n ref = modifyIORef' ref (+1) >> ioProblem2' (n-1) ref

stProblem n = do
    v <- newSTRef 0
    forM_ [0..n-1] $ \i ->
        modifySTRef' v (+1)
    readSTRef v

stProblem2 n = stProblem2' n =<< newSTRef 0

stProblem2' !0 ref = readSTRef ref 
stProblem2' !n ref = modifySTRef' ref (+1) >> stProblem2' (n-1) ref

primProblem n  = primProblem' n 0#

primProblem' 0# acc = I# acc
primProblem' n  acc = primProblem' (n -# 1#) (acc +# 1#)

pureProblem :: Int -> Int
pureProblem n = pureProblem' n 0

pureProblem' 0 acc = acc
pureProblem' n acc = pureProblem' (n-1) (acc+1)


printEmAll n = do
    let !(I# n#) = n
    putStrLn =<< show <$> (benchmarkPure $ pureProblem n)
    putStrLn =<< show <$> (benchmarkPure $ primProblem n#)
    putStrLn =<< show <$> (benchmarkIO   $ ioProblem   n )
    putStrLn =<< show <$> (benchmarkIO   $ ioProblem2   n )
    putStrLn =<< show <$> (benchmarkST   $ stProblem   n )
    putStrLn =<< show <$> (benchmarkST   $ stProblem2   n )

main = do
    args <- getArgs
    case args of
        [n] -> printEmAll (read n)
        _   -> putStrLn help