{-#LANGUAGE OverloadedStrings #-}
{-#LANGUAGE MagicHash         #-}
{-#LANGUAGE BangPatterns      #-}
module Main where

import Control.Monad
import Control.Monad.ST
import Data.STRef
import Data.IORef

import GHC.Prim
import GHC.Types
import Criterion.Measurement

import System.Environment

import Benchmark

help = "The problem: \nBenchmark of a problem: updating a variable n times\n"

ioProblem n = do
    v <- newIORef 0
    forM_ [0..n-1] $ \i ->
        case i `mod` 2 of
            0-> modifyIORef' v (+2)
            1-> modifyIORef' v (+1)
    readIORef v

stProblem n = do
    v <- newSTRef 0
    forM_ [0..n-1] $ \i ->
        case i `mod` 2 of
            0 -> modifySTRef' v (+2)
            1 -> modifySTRef' v (+1)
    readSTRef v

primProblem n  = primProblem' n 0#

primProblem' 0# acc = I# acc
primProblem' n  acc = do
    case (n `remInt#` 2#) of
        0# -> primProblem' (n -# 1#) (acc +# 2#)
        1# -> primProblem' (n -# 1#) (acc +# 1#)


printEmAll n = do
    let !(I# n#) = n
    putStrLn =<< show <$> (benchmarkPure $ primProblem n#)
    putStrLn =<< show <$> (benchmarkIO   $ ioProblem   n )
    putStrLn =<< show <$> (benchmarkST   $ stProblem   n )

main = do
    args <- getArgs
    case args of
        [n] -> printEmAll (read n)
        _   -> putStrLn help