{-#LANGUAGE OverloadedStrings #-}
{-#LANGUAGE MagicHash         #-}
{-#LANGUAGE BangPatterns      #-}
module Main where

import Control.Monad
import Control.Monad.ST
import Data.STRef
import Data.IORef

import GHC.Prim
import GHC.Types
import GHC.Magic
import Criterion.Measurement

import System.Environment

import Benchmark

help = "The problem: \nBenchmark of a problem: updating a variable n times\n"

ioProblem n = do
    v <- newIORef 0
    forM_ [0..n-1] $ \i ->
        if i `mod` 2 == 0
            then modifyIORef' v (+2)
            else modifyIORef' v (+1)
    readIORef v

stProblem n = do
    v <- newSTRef 0
    forM_ [0..n-1] $ \i ->
        if i `mod` 2 == 0
            then modifySTRef' v (+2)
            else modifySTRef' v (+1)
    readSTRef v

primProblem n  = primProblem' n 0#

primProblem' 0# acc = I# acc
primProblem' n  acc = primProblem' (n -# 1#) (acc -# (andI# n 2#) +# 2#)

printEmAll n = do
    let !(I# n#) = n
    --putStrLn =<< show <$> (benchmarkIO   $ ioProblem   n )
    --putStrLn =<< show <$> (benchmarkST   $ stProblem   n )
    putStrLn =<< show <$> (benchmarkPure $ primProblem n#)

main = do
    args <- getArgs
    case args of
        [n] -> printEmAll (read n)
        _   -> putStrLn help